function peak_predict(code,lead_number,peak_size,delays_number)
%-------------------------------------------------------------------------------------------------------------
%This program predicts amplitudes for a subject---------------------------------------------------------------
clc;
%how many instances of the signal to be used---
Type = 'Low';
catstr = 'P200';
st = 71;
fin = 126;
hid1 = 15;
hid2 = 15;
hid3 = 10;
%-------------build string---------------------
%convert delays_number to string---------
str = int2str(delays_number);
%----------------------------------------
pkstr = int2str(peak_size);
%convert electrode number to string--
str2 = int2str(lead_number);
%------------------------------------
%name of file in which net is to be saved and loaded--------
sav = ['lead' str2 '-delays' str '\' catstr '_peaksize-' pkstr];
%-----------------------------------------------------------
%subdirectory name------------------------------------------
S2 = ['C:\Matlab\work\' Type '\' code '\NN-peak\' sav];
%-----------------------------------------------------------
%----------------------------------------------
categ = {'Controls', 'OCD'};
%----------------------------------------------
%manipulate strings and opening the appropriate *.mat file-------
cd (S2);
load('matrices');
%----------------------------------------------------------------
numstr = int2str(num);
global siz;
if (isempty(siz)==1)
    clear global siz;
    siz = 0;
    while (siz > num | siz < 1)
        clc;
        tmtx = ['There are ' numstr ' different trained networks'];
        disp(tmtx);
        tmtx = ['Press 1-' numstr ' to select a subject and predict'];
        disp(tmtx);
        siz = input('the performance with the only net that is not trained for the data:   ');
    end
end
clear siztmp tmtx numstr;
sizstr = int2str(siz);
%---------------------
TEMP(1:peak_size) = prAMP(:,siz);
%build plot label-------
tmp = int2str(siz);
S3 = [code ' ' tmp];
clear tmp;
%----------------------------------------------------------------
%setting time----------------------------------
time = ((px(siz)-peak_size+1+(delays_number+1)*2):2:(px(siz)+peak_size-1));
%----------------------------------------------

%-------------build string---------------------
strhid1 = int2str(hid1);
strhid2 = int2str(hid2);
ststr = int2str(st);
finstr = int2str(fin);
if hid3==0
    lastdir = [strhid1 '-' strhid2 '(' ststr '-' finstr ')'];
else
    strhid3 = int2str(hid3);
    lastdir = [strhid1 '-' strhid2 '-' strhid3 '(' ststr '-' finstr ')'];
end
%----------------------------------------------
%name of directory from which the trained net is to be loaded--------
sav = ['lead' str2 '-delays' str '\' catstr '_peaksize-' pkstr];
%--------------------------------------------------------------------

for j=1:length(categ)
%subdirectory name------------------------------------------
S2 = ['C:\Matlab\work\' Type '\' categ{j} '\NN-peak\' sav '\' lastdir];
%-----------------------------------------------------------
%load the appropriate network or return error-------------------------------------------
try
    cd(S2);
    if strcmp(code,categ{j}) == 1
        tmps = [S2 '\peak_net(' ststr '-' finstr ')ex' sizstr '.mat'];
    else
        tmps = [S2 '\peak_net(' ststr '-' finstr ')ex1.mat'];
    end
    load (tmps);
    clear tmps;
    TEMP2 = tramnmx(TEMP,minM,maxM);
catch
    %disp('Error in loading trained batch network for predicting');
    %error('Enter the appropriate time parameters or train a net with function peak_train');
end
%--------------------------------------------------------------------------------------
%plotting phase 1--------------------------------------------------------------
plot(time,TEMP((delays_number+2):peak_size),'-g');
hold on;
legend(S3,4);
axis([0 1022 -30 30]);
xlabel('Time');
ylabel('Amplitude');
stitle=['Lead ' str2 ' | delays: ' str];
title(stitle);
%----------------------------------------------
disp('------------------------------------------------------------------------------------------------------');
disp('Press a key to continue');
%----------------------------------------------
plot([0 1022],[0 0],'k');
legend(S3,'zero',4);
t = TEMP((delays_number+2):peak_size);  %temp matrix t for error plotting
%end plotting phase 1----------------------------------------------------------

%build inputs and initial delays-------------------------------------
P = TEMP2(delays_number+1);
Pf = TEMP2(1:delays_number);
clear TEMP2;
%--------------------------------------------------------------------

%NET adapt and plotting----------------------------------------------------------
%initializing output, error and time
YN=P; EP1=0; TimeN=time(1); SUM=0; tmcnt=0;
%-----------------------------------
for i=1:(peak_size-delays_number-1) 
    TimeO=TimeN;
    TimeN=time(i);
    YO=YN;
    [Y,Pf] = sim(net,YN,Pf);
    YN=Y(1);
    %postprocessing for accurate plotting
    YP1 = postmnmx(YN,minM,maxM);
    YP0 = postmnmx(YO,minM,maxM);
    %------------------------------------
    %indirect calculation of the error for displaying
    EP0 = EP1;
    EP1 = YP1 - t(i);
    %if i < 36
        SUM = SUM + EP1*EP1;
        tmcnt = tmcnt + 1;
    %end
    %---------------------
    %plot error and output
    plot([TimeO TimeN],[YP1 YP0],'b',[TimeO TimeN],[EP0 EP1],'r');
    %---------------------
    %legend-----------------------------------
    if i==1
       legend(S3,'zero','Output','Error',4);
    end
    %-----------------------------------------
    drawnow;
end
%calculating and displaying MSE---------
MErr = SUM/tmcnt;
strMSE = num2str(MErr,5);
dstr = ['MSE=' strMSE];
text(20,20,dstr);
dstr = [categ{j} ' ex' sizstr ' perf:'];
text(20,17,dstr);
strperf = num2str(perf);
text(50,15,strperf);
hold off;
%---------------------------------------
tmstr = [S3 '-' categ{j}];
print('-f1','-dbmp','-r100', tmstr);
clear minM maxM;
end